/* $Id: pixel.c,v 1.5 2001/10/07 23:14:13 skids Exp $
******************************************************************************

   Graphics library for GGI.  Pixels with 8-bit Z.

   Copyright (C) 1997 Jason McMullan [jmcc@ggi-project.org]
   Copyright (C) 1995 Andreas Beck [becka@ggi-project.org]
   Copyright (C) 2001 Brian S. Julin [bri@tull.umassp.edu]

   Permission is hereby granted, free of charge, to any person obtaining a
   copy of this software and associated documentation files (the "Software"),
   to deal in the Software without restriction, including without limitation
   the rights to use, copy, modify, merge, publish, distribute, sublicense,
   and/or sell copies of the Software, and to permit persons to whom the
   Software is furnished to do so, subject to the following conditions:

   The above copyright notice and this permission notice shall be included in
   all copies or substantial portions of the Software.

   THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
   IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
   FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL
   THE AUTHOR(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
   IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
   CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

******************************************************************************
*/


#include "stubs-z8-lib.h"

/*******************************/
/* draw/get/put a single pixel */
/*******************************/


int GGI_stubs_z8_drawpixel(ggi_visual *vis,int x,int y)
{
	Z8_COMMON_DECLS;
	u_int8_t z;
	
	CHECKXY(vis,x,y);

	Z_COMMON_INIT;

	zbuf->storage_ops->storage2mem(priv->zbuf->storage, x, y, 0, 
                                       &z, 1, 1, 1);

	Z_SWITCH_SINGLE(z,
			priv->old_opdraw->drawpixel_nc(vis, x, y),
			zbuf->storage_ops->mem2storage(priv->zbuf->storage, 
						       x, y, 0, 
						       &defz, 1, 1, 1)
			);
	return 0;
}

int GGI_stubs_z8_drawpixel_nc(ggi_visual *vis,int x,int y)
{
	Z8_COMMON_DECLS;
	u_int8_t z;
	Z_COMMON_INIT;

	zbuf->storage_ops->storage2mem(priv->zbuf->storage, x, y, 0, 
                                       &z, 1, 1, 1);

	Z_SWITCH_SINGLE(z,
			priv->old_opdraw->drawpixel_nc(vis, x, y),
			zbuf->storage_ops->mem2storage(priv->zbuf->storage, 
						       x, y, 0, 
						       &defz, 1, 1, 1)
			);
	return 0;
}

int GGI_stubs_z8_putpixel(ggi_visual *vis,int x,int y,ggi_pixel col)
{ 
	Z8_COMMON_DECLS;
	u_int8_t z;

	CHECKXY(vis,x,y);

	Z_COMMON_INIT;

	zbuf->storage_ops->storage2mem(priv->zbuf->storage, x, y, 0, 
                                       &z, 1, 1, 1);

	Z_SWITCH_SINGLE(z,
			priv->old_opdraw->putpixel_nc(vis, x, y, col),
			zbuf->storage_ops->mem2storage(priv->zbuf->storage, 
						       x, y, 0, 
						       &defz, 1, 1, 1)
			);

	return 0;
}


int GGI_stubs_z8_putpixel_nc(ggi_visual *vis,int x,int y,ggi_pixel col)
{ 
	Z8_COMMON_DECLS;
	u_int8_t z;

	Z_COMMON_INIT;

	zbuf->storage_ops->storage2mem(priv->zbuf->storage, x, y, 0, 
                                       &z, 1, 1, 1);

	Z_SWITCH_SINGLE(z,
			priv->old_opdraw->putpixel_nc(vis, x, y, col),
			zbuf->storage_ops->mem2storage(priv->zbuf->storage, 
						       x, y, 0, 
						       &defz, 1, 1, 1)
			);
	return 0;
}

